import { Subject, Unsubscribable } from 'rxjs';
import { Effect } from '../types';
export interface CommonUndoEvent<T, V> {
    type: T;
    payload: {
        prev: V;
        next: V;
    };
}
type EffectExtract<T, E> = Extract<E, {
    type: T;
}>;
export interface UndoRedoEffectConfig<V, A, E extends CommonUndoEvent<string, unknown>, T> {
    filterActions?: Array<keyof A>;
    filter?: (event: EffectExtract<T, E>, value: V) => boolean;
}
export interface UndoRedoModule<E extends CommonUndoEvent<string, unknown>> extends Unsubscribable {
    undo: Subject<void>;
    redo: Subject<void>;
    onChange: Subject<E>;
    onUndo: Subject<E>;
    onRedo: Subject<E>;
    removeLastEvent: () => void;
    startBunch: () => void;
    endBunch: () => void;
    createUndoRedoEffect: <V, A, T extends E['type']>(type: T, config?: UndoRedoEffectConfig<V, A, E, T>) => () => Effect<V, A>;
}
export declare const generateId: () => string;
export declare const undoRedoModule: <E extends CommonUndoEvent<string, unknown>>(size?: number) => UndoRedoModule<E>;
export {};
